;-----------------------------------------------------;
; Add all the MugShot files to the project and do the ;
; appropriate includes as listed below:               ;
;     In the .asm file use, include MugShot.asm       ;
;     In the .rc  file use, #include <MugShot.rc>     ;
; Finally, add the code below to the Messaging loop.  ;
;-----------------------------------------------------;
; .ElseIf Eax == IDM_ABOUT                            ;
;   invoke  CreateDialogParam, hInst, addr AboutName, ;
;           hWnd, OFFSET AboutDlgProc, NULL           ;
;-----------------------------------------------------;

AboutDlgProc        PROTO  hWnd:HWND, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
HyperLinkWndProc    PROTO   :DWORD, :DWORD, :DWORD, :DWORD
;
.const
;---------------------------------------
IDC_URL             equ 9
IDC_EXIT            equ 3002
;
.data
;---------------------------------------;
AboutName      db  "AboutDialog", 0     ; About Box Name
szOpen         db  "open", 0            ; Action to perform
;
.data?
;---------------------------------------
hover           BOOL    ?
orgStatic       DD      ?
hFinger         DD      ?
buff            db      256 dup (?)
;
.code
;---------------------------------------
HyperLinkWndProc proc uses ebx HWnd:DWORD,
                      uMsg:DWORD,
                      wParam:DWORD,
                      lParam:DWORD
;---------------------------------------
        Local   tmpFont:LOGFONT
        Local   rect:RECT
        Local   pt:POINT
;
        mov     eax, uMsg
        .if eax==WM_NCHITTEST
          mov     eax, 1                ; We want to handle the non client hit test so we return true or 1
          ret
        .elseif eax == WM_CTLCOLORSTATIC
          push    ebx
          push    edx
          invoke  SendMessage, HWnd, WM_GETFONT, 0, 0
          mov     edx, eax
          invoke  GetObject, edx, sizeof LOGFONT, addr tmpFont
          mov     tmpFont.lfUnderline, TRUE
          invoke  CreateFontIndirect, addr tmpFont
          mov     ebx, eax
          invoke  SelectObject, wParam, ebx
          .if hover == FALSE
            invoke  SetTextColor, wParam, Blue
          .else
            invoke  SetTextColor, wParam, Red
          .endif
          invoke  GetSysColor, COLOR_MENU
          invoke  SetBkColor, wParam, eax
          invoke  DeleteObject, ebx
          invoke  GetStockObject, HOLLOW_BRUSH
          pop     edx
          pop     ebx
          ret
        .elseif eax==WM_MOUSEMOVE
          invoke  GetParent, HWnd
          push    ebx
          mov     ebx, eax
          invoke  GetActiveWindow
          .if eax == ebx
            invoke  GetCursorPos, addr pt
            invoke  GetWindowRect, HWnd, addr rect
            invoke  PtInRect, addr rect, pt.x, pt.y
            .if eax
              invoke  GetCapture
              .if !eax
                invoke  SetCapture, HWnd
                mov     hover, TRUE
                invoke  InvalidateRect, HWnd, FALSE, FALSE
                invoke  SetCursor, hFinger
              .endif
            .else
              invoke  GetCapture
              .if eax
                invoke  ReleaseCapture
                mov     hover, FALSE
                invoke  InvalidateRect, HWnd, FALSE, FALSE
              .endif
            .endif
          .endif
          pop     ebx
          xor     eax, eax
          ret
        .elseif eax==WM_LBUTTONDOWN
          invoke  GetWindowText, HWnd, offset buff, sizeof buff ; Change this for using a preset url
          invoke  ShellExecute, NULL, offset szOpen, offset buff, NULL, NULL, SW_MAXIMIZE   ; Change this to represent your preset url
          mov     hover, FALSE
          invoke  InvalidateRect, HWnd, FALSE, FALSE
          invoke  SendMessage, HWnd, WM_GETFONT, 0, 0           ; Get the defualt system font
          mov     edx, eax                                      ; Store result
          invoke  GetObject, edx, sizeof LOGFONT, addr tmpFont  ; Get our font into a logfont structure
          mov     tmpFont.lfUnderline, TRUE                     ; Under line the link
          invoke  CreateFontIndirect, addr tmpFont              ; Create the new font
          mov     ebx, eax                                      ; We need the return to free the memory later
          invoke  SelectObject, wParam, ebx                     ; Select our control
          invoke  SetTextColor, wParam, Blue                    ; Change this to change the color of the link
          xor     eax, eax                                      ; No errors
          ret                                                   ; Return
        .endif
        invoke  CallWindowProc, orgStatic, HWnd, uMsg, wParam, lParam   ;Passes message information to the next stop
        ret                                                 ; Return
;---------------------------------------
HyperLinkWndProc endp
;
;
AboutDlgProc proc hwnd:HWND, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
        mov     eax, iMsg
        .if eax==WM_INITDIALOG
          invoke  GetDlgItem, hwnd, IDC_URL
          invoke  SetWindowLong, eax, GWL_WNDPROC, ADDR HyperLinkWndProc
          mov     orgStatic, eax
          mov     hFinger, eax
          xor     eax, eax
          ret
        .elseif eax == WM_CTLCOLORSTATIC
          invoke  SendMessage, lParam, iMsg, wParam, lParam
          ret
        .elseif eax==WM_CLOSE
          invoke  EndDialog, hwnd, NULL
        .elseif eax==WM_COMMAND
          push    edx
          mov     eax, wParam
          mov     edx, eax
          shr     edx, 16
          .if eax==IDC_EXIT
            invoke  SendMessage, hwnd, WM_CLOSE, NULL, NULL
            invoke  EndDialog, hwnd, NULL
          .endif
          pop     edx
        .else
          mov     eax, FALSE
          ret
        .endif
        mov      eax, TRUE
        ret
;---------------------------------------
AboutDlgProc endp
